# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import warnings
import pulumi
import pulumi.runtime
from . import utilities, tables

class Group(pulumi.CustomResource):
    description: pulumi.Output[str]
    """
    The description of the group.
    """
    full_name: pulumi.Output[str]
    """
    The full name of the group.
    """
    full_path: pulumi.Output[str]
    """
    The full path of the group.
    """
    lfs_enabled: pulumi.Output[bool]
    """
    Boolean, defaults to true.  Whether to enable LFS
    support for projects in this group.
    """
    name: pulumi.Output[str]
    """
    The name of this group.
    """
    parent_id: pulumi.Output[float]
    """
    Integer, id of the parent group (creates a nested group).
    """
    path: pulumi.Output[str]
    """
    The path of the group.
    """
    request_access_enabled: pulumi.Output[bool]
    """
    Boolean, defaults to false.  Whether to
    enable users to request access to the group.
    """
    visibility_level: pulumi.Output[str]
    """
    Set to `public` to create a public group.
    Valid values are `private`, `internal`, `public`.
    Groups are created as private by default.
    """
    web_url: pulumi.Output[str]
    """
    Web URL of the group.
    """
    def __init__(__self__, resource_name, opts=None, description=None, lfs_enabled=None, name=None, parent_id=None, path=None, request_access_enabled=None, visibility_level=None, __name__=None, __opts__=None):
        """
        This resource allows you to create and manage GitLab groups.
        Note your provider will need to be configured with admin-level access for this resource to work.
        
        ## Importing groups
        
        You can import a group state using `terraform import <resource> <id>`.  The
        `id` can be whatever the [details of a group][details_of_a_group] api takes for
        its `:id` value, so for example:
        
            terraform import gitlab_group.example example
        
        [details_of_a_group]: https://docs.gitlab.com/ee/api/groups.html#details-of-a-group
        
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] description: The description of the group.
        :param pulumi.Input[bool] lfs_enabled: Boolean, defaults to true.  Whether to enable LFS
               support for projects in this group.
        :param pulumi.Input[str] name: The name of this group.
        :param pulumi.Input[float] parent_id: Integer, id of the parent group (creates a nested group).
        :param pulumi.Input[str] path: The path of the group.
        :param pulumi.Input[bool] request_access_enabled: Boolean, defaults to false.  Whether to
               enable users to request access to the group.
        :param pulumi.Input[str] visibility_level: Set to `public` to create a public group.
               Valid values are `private`, `internal`, `public`.
               Groups are created as private by default.
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if not resource_name:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(resource_name, str):
            raise TypeError('Expected resource name to be a string')
        if opts and not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        __props__['description'] = description

        __props__['lfs_enabled'] = lfs_enabled

        __props__['name'] = name

        __props__['parent_id'] = parent_id

        if path is None:
            raise TypeError("Missing required property 'path'")
        __props__['path'] = path

        __props__['request_access_enabled'] = request_access_enabled

        __props__['visibility_level'] = visibility_level

        __props__['full_name'] = None
        __props__['full_path'] = None
        __props__['web_url'] = None

        super(Group, __self__).__init__(
            'gitlab:index/group:Group',
            resource_name,
            __props__,
            opts)


    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

