# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import warnings
import pulumi
import pulumi.runtime
from . import utilities, tables

class GroupVariable(pulumi.CustomResource):
    group: pulumi.Output[str]
    """
    The name or id of the group to add the hook to.
    """
    key: pulumi.Output[str]
    """
    The name of the variable.
    """
    protected: pulumi.Output[bool]
    """
    If set to `true`, the variable will be passed only to pipelines running on protected branches and tags. Defaults to `false`.
    """
    value: pulumi.Output[str]
    """
    The value of the variable.
    """
    def __init__(__self__, resource_name, opts=None, group=None, key=None, protected=None, value=None, __name__=None, __opts__=None):
        """
        This resource allows you to create and manage CI/CD variables for your GitLab groups.
        For further information on variables, consult the [gitlab
        documentation](https://docs.gitlab.com/ce/ci/variables/README.html#variables).
        
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] group: The name or id of the group to add the hook to.
        :param pulumi.Input[str] key: The name of the variable.
        :param pulumi.Input[bool] protected: If set to `true`, the variable will be passed only to pipelines running on protected branches and tags. Defaults to `false`.
        :param pulumi.Input[str] value: The value of the variable.
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if not resource_name:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(resource_name, str):
            raise TypeError('Expected resource name to be a string')
        if opts and not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if group is None:
            raise TypeError("Missing required property 'group'")
        __props__['group'] = group

        if key is None:
            raise TypeError("Missing required property 'key'")
        __props__['key'] = key

        __props__['protected'] = protected

        if value is None:
            raise TypeError("Missing required property 'value'")
        __props__['value'] = value

        super(GroupVariable, __self__).__init__(
            'gitlab:index/groupVariable:GroupVariable',
            resource_name,
            __props__,
            opts)


    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

