# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import warnings
import pulumi
import pulumi.runtime
from . import utilities, tables

class ServiceJira(pulumi.CustomResource):
    active: pulumi.Output[bool]
    created_at: pulumi.Output[str]
    jira_issue_transition_id: pulumi.Output[str]
    """
    The ID of a transition that moves issues to a closed state. You can find this number under the JIRA workflow administration (Administration > Issues > Workflows) by selecting View under Operations of the desired workflow of your project. By default, this ID is set to 2.
    """
    password: pulumi.Output[str]
    """
    The password of the user created to be used with GitLab/JIRA.
    """
    project: pulumi.Output[str]
    """
    ID of the project you want to activate integration on.
    """
    project_key: pulumi.Output[str]
    """
    The short identifier for your JIRA project, all uppercase, e.g., PROJ.
    """
    title: pulumi.Output[str]
    updated_at: pulumi.Output[str]
    url: pulumi.Output[str]
    """
    The URL to the JIRA project which is being linked to this GitLab project. For example, https://jira.example.com.
    """
    username: pulumi.Output[str]
    """
    The username of the user created to be used with GitLab/JIRA.
    """
    def __init__(__self__, resource_name, opts=None, jira_issue_transition_id=None, password=None, project=None, project_key=None, url=None, username=None, __name__=None, __opts__=None):
        """
        This resource allows you to manage Jira integration.
        
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] jira_issue_transition_id: The ID of a transition that moves issues to a closed state. You can find this number under the JIRA workflow administration (Administration > Issues > Workflows) by selecting View under Operations of the desired workflow of your project. By default, this ID is set to 2.
        :param pulumi.Input[str] password: The password of the user created to be used with GitLab/JIRA.
        :param pulumi.Input[str] project: ID of the project you want to activate integration on.
        :param pulumi.Input[str] project_key: The short identifier for your JIRA project, all uppercase, e.g., PROJ.
        :param pulumi.Input[str] url: The URL to the JIRA project which is being linked to this GitLab project. For example, https://jira.example.com.
        :param pulumi.Input[str] username: The username of the user created to be used with GitLab/JIRA.
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if not resource_name:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(resource_name, str):
            raise TypeError('Expected resource name to be a string')
        if opts and not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        __props__['jira_issue_transition_id'] = jira_issue_transition_id

        if password is None:
            raise TypeError("Missing required property 'password'")
        __props__['password'] = password

        if project is None:
            raise TypeError("Missing required property 'project'")
        __props__['project'] = project

        __props__['project_key'] = project_key

        if url is None:
            raise TypeError("Missing required property 'url'")
        __props__['url'] = url

        if username is None:
            raise TypeError("Missing required property 'username'")
        __props__['username'] = username

        __props__['active'] = None
        __props__['created_at'] = None
        __props__['title'] = None
        __props__['updated_at'] = None

        super(ServiceJira, __self__).__init__(
            'gitlab:index/serviceJira:ServiceJira',
            resource_name,
            __props__,
            opts)


    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

